############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXFrameBuffer;no warnings;require NXVirtualSession;require 
NXClientSystemDaemons;(my $__startingXserver=(0x0501+ 3709-0x137e));(my $__nxFrameBufferRunning
=(""));(my $__error=(""));(my $__username=(""));(my $__geometry=(""));(my $__clientNotAsked
=(0x04cb+ 6991-0x2019));($message_started=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x72\x74\x65\x64"
);($message_abortedXserverFound=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x65\x64\x2e\x20\x52\x65\x61\x73\x6f\x6e\x3a\x20\x77\x6f\x72\x6b\x69\x6e\x67\x20\x58\x73\x65\x72\x76\x65\x72\x20\x66\x6f\x75\x6e\x64"
);($message_abortedFrameBufferRunning=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x65\x64\x2e\x20\x52\x65\x61\x73\x6f\x6e\x3a\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67"
);($message_abortedFrameBufferDisabled=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x65\x64\x2e\x20\x52\x65\x61\x73\x6f\x6e\x3a\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x20\x64\x69\x73\x61\x62\x6c\x65\x64"
);($message_abortedWrongRequest=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x65\x64\x2e\x20\x52\x65\x61\x73\x6f\x6e\x3a\x20\x77\x72\x6f\x6e\x67\x20\x72\x65\x71\x75\x65\x73\x74"
);($message_errorStarting=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x65\x72\x72\x6f\x72\x20\x77\x68\x69\x6c\x65\x20\x73\x74\x61\x72\x74\x69\x6e\x67"
);($__stateMachineInitialized=(0x0dc0+ 2990-0x196e));($defaultConnection=
"\x31\x32\x37\x2e\x30\x2e\x30\x2e\x31\x20\x30\x20\x31\x32\x37\x2e\x30\x2e\x30\x2e\x31\x20\x30"
);sub handleNxFrameBuffer{initializeStateMachine ();
NXShell::registerStateMachine (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x3a\x3a\x72\x75\x6e",
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x3a\x3a\x67\x65\x74\x54\x69\x6d\x65\x6f\x75\x74"
,
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x3a\x3a\x69\x73\x52\x65\x61\x64\x79"
);NXShell::stopGetCommandStateMachine ();run ();return ((0x1619+ 424-0x17c1));}
sub initializeStateMachine{if (stateMachineInitialized ()){setCurrentState (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72");
return ((0x1825+  31-0x1844));}initializeMessages ();addState (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x48\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
);addTransition (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x61\x73\x6b\x55\x73\x65\x72\x54\x6f\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
,"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72");
addTransition (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x73\x74\x61\x72\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x6c\x79");
addTransition (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x73\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");addState (
"\x61\x73\x6b\x55\x73\x65\x72\x54\x6f\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
,
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x41\x73\x6b\x55\x73\x65\x72\x54\x6f\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
);addTransition (
"\x61\x73\x6b\x55\x73\x65\x72\x54\x6f\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
,"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x75\x73\x65\x72\x41\x73\x6b\x65\x64");addState (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x57\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65"
);addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x52\x65\x63\x65\x69\x76\x65\x64"
);addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x73\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
,
"\x73\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
);addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,
"\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
);addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x65\x72\x72\x6f\x72");setWaitInSelect (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65");
addState (
"\x73\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
,
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x53\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
);addTransition (
"\x73\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
,"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x53\x61\x76\x65\x64");addState (
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
);addTransition (
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x65\x72\x72\x6f\x72");addTransition (
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
,"\x73\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x41\x73\x6b\x65\x64");
addState (
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
,
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x57\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
);setWaitInSelect (
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
,$GLOBAL::timeoutForServerDaemonResponseOnStartNxFrameBuffer);addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
,
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x73\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
,
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x65\x72\x72\x6f\x72");addState (
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
);addTransition (
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x66\x69\x6e\x69\x73\x68\x65\x64","\x66\x69\x6e\x69\x73\x68");addState (
"\x66\x69\x6e\x69\x73\x68\x65\x64",
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x46\x69\x6e\x69\x73\x68\x65\x64"
);addTransition ("\x66\x69\x6e\x69\x73\x68\x65\x64",
"\x63\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65",
"\x63\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65");addState
 ("\x63\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65",
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x43\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65"
);setFinalState (
"\x63\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65");
setCurrentState (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72");
setStateMachineInitialized ();}sub stateMachineInitialized{return (
$__stateMachineInitialized);}sub setStateMachineInitialized{(
$__stateMachineInitialized=(0x0eb0+ 5396-0x23c3));}sub run{Logger::debug ((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x53\x74\x61\x72\x74\x20\x69\x6e\x20\x73\x74\x61\x74\x65\x3a\x20"
.getCurrentState ()));while (isReady ()){handleCurrentState ();}Logger::debug ((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x53\x74\x6f\x70\x20\x69\x6e\x20\x73\x74\x61\x74\x65\x3a\x20"
.getCurrentState ()));}sub isReady{if ((isFinalState ()==(0x0191+ 1214-0x064e)))
{return ((0x098d+ 5684-0x1fc1));}if ((isWaitingInSelect ()==
(0x137f+ 2125-0x1bcb))){if ((getCurrentState ()eq 
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
)){NXShell::registerDescriptor (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
NXClientSystemDaemons::getSocketToServerDaemon (),(\&callbackFromServerDaemon),
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x3a\x3a\x63\x61\x6c\x6c\x62\x61\x63\x6b\x46\x72\x6f\x6d\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e"
);NXShell::registerDescriptor (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
NXClientSystemDaemons::getSocketToServerDaemon (),(
\&callbackFromServerDaemonClosed),
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x3a\x3a\x63\x61\x6c\x6c\x62\x61\x63\x6b\x46\x72\x6f\x6d\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x43\x6c\x6f\x73\x65\x64"
,"\x43\x6c\x6f\x73\x65");}return ((0x11ea+ 5175-0x2621));}return (
(0x1818+ 1795-0x1f1a));}sub callbackFromServerDaemon{(my $self=shift (@_));(my $handleHash
=shift (@_));(my $readBuffer=shift (@_));(my $readBytes=shift (@_));$self->
removeAndCloseHandle ($$handleHash{"\x48\x61\x6e\x64\x6c\x65"});$self->setExit (
$handleHash,(0x055b+ 2252-0x0e27),(0x041d+ 4634-0x1637));Logger::debug (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x52\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x74\x68\x65\x20\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x3a\x20"
.$readBuffer)."\x2e"));if ((($readBuffer eq getMessageStarted ())or ($readBuffer
 eq getMessageFrameBufferRunning ()))){NXMsg::send_response (
"\x69\x43\x4d\x44\x58\x73\x65\x72\x76\x65\x72\x53\x74\x61\x72\x74\x65\x64",
"\x73\x65\x73\x73\x69\x6f\x6e");setNextState (
"\x73\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");}elsif (($readBuffer eq 
getMessageXserverFound ())){setNextState (
"\x73\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");NXMsg::send_response (
"\x69\x43\x4d\x44\x58\x73\x65\x72\x76\x65\x72\x4e\x6f\x74\x53\x74\x61\x72\x74\x65\x64\x58\x46\x6f\x75\x6e\x64"
,"\x73\x65\x73\x73\x69\x6f\x6e");}else{Logger::error ((
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x65\x72\x72\x6f\x72\x20\x66\x72\x6f\x6d\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20"
.$readBuffer));NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,"\x73\x65\x73\x73\x69\x6f\x6e");setNextState ("\x65\x72\x72\x6f\x72");}}sub 
callbackFromServerDaemonClosed{(my $self=shift (@_));(my $handleHash=shift (@_))
;$self->removeAndCloseHandle ($$handleHash{"\x48\x61\x6e\x64\x6c\x65"});$self->
setExit ($handleHash,(0x21fa+ 1167-0x2689),(0x077b+ 7226-0x23b5));Logger::error 
(
"\x53\x6f\x63\x6b\x65\x74\x20\x74\x6f\x20\x74\x68\x65\x20\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x63\x6c\x6f\x73\x65\x64\x20\x75\x6e\x65\x78\x70\x65\x63\x74\x65\x64\x6c\x79"
);NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,"\x73\x65\x73\x73\x69\x6f\x6e");setNextState ("\x65\x72\x72\x6f\x72");}sub 
getTimeout{(my $currentState=getCurrentState ());if (defined ($waitInSelect{
$currentState})){return ($waitInSelect{$currentState});}else{return (
(0x005f+ 2646-0x0ab5));}}sub addState{(my $stateName=shift (@_));(my $functionToHandle
=shift (@_));if (($stateName eq (""))){Logger::error (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x73\x74\x61\x74\x65\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x1af1+ 1354-0x203b));}if (($functionToHandle eq (""))){
Logger::error (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x68\x61\x6e\x64\x6c\x65\x20\x73\x74\x61\x74\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x0b54+ 1437-0x10f1));}($states{$stateName}=$functionToHandle);
}sub addTransition{(my $beginState=shift (@_));(my $nextState=shift (@_));(my $event
=shift (@_));(my $break=shift (@_));if (($beginState eq (""))){(my ($package,
$filename,$line,$sub)=caller ((0x18c9+ 932-0x1c6c)));Logger::error (((((((((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x61\x64\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x3a\x20\x62\x65\x67\x69\x6e\x20\x73\x74\x61\x74\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e\x20\x28"
.$package)."\x2c\x20").$filename)."\x2c\x20").$line)."\x2c\x20").$sub)."\x29"));
main::nxexit ((0x1961+ 2894-0x24af));}if (($nextState eq (""))){Logger::error ((
(
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x61\x64\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20\x73\x74\x61\x74\x65\x20"
.$beginState).
"\x3a\x20\x6e\x65\x78\x74\x20\x73\x74\x61\x74\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
));main::nxexit ((0x0709+ 258-0x080b));}if (($event eq (""))){Logger::error (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x61\x64\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20\x73\x74\x61\x74\x65\x20"
.$beginState).
"\x3a\x20\x65\x76\x65\x6e\x74\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
));main::nxexit ((0x0000+ 9792-0x2640));}($transition{$beginState}{$event}=
$nextState);}sub setFinalState{(my $stateName=shift (@_));($finalState{
$stateName}=(0x0a4a+ 1498-0x1023));}sub setWaitInSelect{(my $stateName=shift (@_
));(my $timeout=shift (@_));if (($timeout eq (""))){($timeout="\x69\x6e\x66");}
if (($stateName eq (""))){Logger::error (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x2c\x20\x77\x61\x69\x74\x20\x69\x6e\x20\x6e\x78\x73\x68\x65\x6c\x6c\x3a\x20\x73\x74\x61\x74\x65\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x0ab6+ 724-0x0d8a));}($waitInSelect{$stateName}=$timeout);}sub
 isFinalState{(my $stateName=getCurrentState ());if (($finalState{$stateName}ne 
(""))){return ((0x10d8+ 4331-0x21c2));}}sub isWaitingInSelect{(my $stateName=
getCurrentState ());if (($waitInSelect{$stateName}ne (""))){return (
(0x0fba+ 3028-0x1b8d));}return ((0x10c6+ 4070-0x20ac));}sub getCurrentState{
return ($currentState);}sub setCurrentState{($currentState=shift (@_));}sub 
handleCurrentState{(my $currentState=getCurrentState ());(my $functionToHandle=
$states{$currentState});if (($functionToHandle eq (""))){Logger::error (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x69\x6e\x20\x73\x74\x61\x74\x65\x20"
.$currentState).
"\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x68\x61\x6e\x64\x6c\x65\x2e"
));main::nxexit ((0x1e87+ 1740-0x2553));}Logger::debug (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x73\x74\x61\x74\x65\x3a\x20"
.$currentState)."\x2e"));return (\(&$functionToHandle (@_)));}sub setNextState{(my $event
=shift (@_));if (($event eq (""))){Logger::error (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x69\x6e\x20\x73\x74\x61\x74\x65\x20"
.$currentState).
"\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x64\x65\x63\x69\x64\x65\x20\x61\x62\x6f\x75\x74\x20\x6e\x65\x77\x20\x73\x74\x61\x74\x65\x20\x77\x69\x74\x68\x20\x65\x6d\x70\x74\x79\x20\x65\x76\x65\x6e\x74\x2e"
));main::nxexit ((0x06aa+ 7005-0x2207));}(my $nextState=getTransition ($event));
setCurrentState ($nextState);if (isWaitingInSelect ()){($__startWait=
Common::NXTime::getSecondsSinceEpoch ());}}sub getTransition{(my $event=shift (
@_));(my $currentState=getCurrentState ());if (($currentState eq (""))){(my (
$package,$filename,$line,$sub)=caller ((0x01f1+ 6825-0x1c99)));Logger::error (((
((((((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20\x65\x6d\x70\x74\x79\x20\x73\x74\x61\x74\x65\x2e\x20\x28"
.$package)."\x2c\x20").$filename)."\x2c\x20").$line)."\x2c\x20").$sub)."\x29"));
main::nxexit ((0x0530+ 2732-0x0fdc));}if (($event eq (""))){Logger::error (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x6f\x72\x20\x65\x6d\x70\x74\x79\x20\x65\x76\x65\x6e\x74\x20\x28"
.$currentState)."\x29\x2e"));main::nxexit ((0x1acd+ 1631-0x212c));}(my $nextState
=$transition{$currentState}{$event});if (($nextState eq (""))){Logger::error (((
((
"\x47\x65\x74\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x77\x69\x74\x68\x20\x65\x76\x65\x6e\x74\x20"
.$event)."\x20\x28").$currentState)."\x29\x2e"));main::nxexit (
(0x05a6+ 4756-0x183a));}Logger::debug (((((((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x54\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20"
.$currentState)."\x20\x77\x69\x74\x68\x20\x65\x76\x65\x6e\x74\x20").$event).
"\x20\x69\x73\x20").$nextState)."\x2e"));return ($nextState);}sub 
__handleStateSaveNxFrameBufferParametersInConfig{saveParametersInConfigFile ();
setNextState ("\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x53\x61\x76\x65\x64");}
sub __handleStateStartNxFrameBuffer{if ((NXClientSystemDaemons::openConnection 
()!=(0x171c+ 241-0x180c))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,"\x73\x65\x73\x73\x69\x6f\x6e");setNextState ("\x65\x72\x72\x6f\x72");return (
(0x06db+ 7558-0x2461));}my ($connection);if ((libnxh::NXTransGetEnvironment (
"\x4e\x58\x5f\x43\x4f\x4e\x4e\x45\x43\x54\x49\x4f\x4e")ne (""))){($connection=
libnxh::NXTransGetEnvironment (
"\x4e\x58\x5f\x43\x4f\x4e\x4e\x45\x43\x54\x49\x4f\x4e"));}elsif ((
libnxh::NXTransGetEnvironment (
"\x53\x53\x48\x5f\x43\x4f\x4e\x4e\x45\x43\x54\x49\x4f\x4e")ne (""))){(
$connection=libnxh::NXTransGetEnvironment (
"\x53\x53\x48\x5f\x43\x4f\x4e\x4e\x45\x43\x54\x49\x4f\x4e"));}else{($connection=
$defaultConnection);}(my $message=(((((((("\x4e\x58\x3e\x20".
$GLOBAL::MSG_START_FRAME_BUFFER).
"\x20\x53\x74\x61\x72\x74\x20\x76\x69\x72\x74\x75\x61\x6c\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x20\x75\x73\x65\x72\x6e\x61\x6d\x65\x3d"
).main::urlencode (getUsername ()))."\x20\x67\x65\x6f\x6d\x65\x74\x72\x79\x3d").
main::urlencode (getGeometry ())).
"\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x3d").main::urlencode ($connection
))."\x20\x0a"));if ((NXClientSystemDaemons::sendMessage ($message)!=
(0x1132+ 1660-0x17ad))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,"\x73\x65\x73\x73\x69\x6f\x6e");setNextState ("\x65\x72\x72\x6f\x72");
NXClientSystemDaemons::closeConnection ();return ((0x1b11+ 253-0x1c0e));}
setNextState (
"\x73\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x41\x73\x6b\x65\x64");}sub 
__handleStateFinished{NXShell::setExitRequestCommandFinished ();
NXShell::unregisterStateMachine (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72");
NXShell::startGetCommandStateMachine ();setNextState (
"\x63\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65");}sub 
__handleStateHandleNxFrameBuffer{if (shouldStartNewXserver ()){Logger::debug (
"\x4e\x58\x53\x65\x73\x73\x69\x6f\x6e\x42\x75\x66\x66\x65\x72\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2c\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x6c\x79\x2e"
);setNextState (
"\x73\x74\x61\x72\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x6c\x79");return (
(0x0d2a+ 5087-0x2109));}if ((NXSession2::getNumberOfRunningSessionsFound ()==
(0x0116+ 8878-0x23c4))){if ((Server::isClientSupportingNxFrameBufferFeature ()
and clientNotAsked ())){setNextState (
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72");
return ((0x01c1+ 773-0x04c6));}}else{if ((checkIsNxFrameBufferSessionsReady ()==
(0x0168+ 7669-0x1f5c))){Logger::debug (
"\x4e\x58\x53\x65\x73\x73\x69\x6f\x6e\x42\x75\x66\x66\x65\x72\x20\x69\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);NXMsg::send_response (
"\x69\x43\x4d\x44\x58\x73\x65\x72\x76\x65\x72\x53\x74\x61\x72\x74\x65\x64",
"\x73\x65\x73\x73\x69\x6f\x6e");}}setNextState (
"\x73\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");}sub 
__handleStateAskUserToStartNxFrameBuffer{NXMsg::send_response (
"\x69\x43\x4d\x44\x41\x73\x6b\x49\x66\x43\x72\x65\x61\x74\x65\x58\x73\x65\x72\x76\x65\x72"
,"\x73\x65\x73\x73\x69\x6f\x6e");setClientAsked ();setNextState (
"\x75\x73\x65\x72\x41\x73\x6b\x65\x64");}sub 
__handleStateWaitForServerDaemonResponse{();}sub 
__handleStateContinueListSessions{main::nxrequire (
"\x4e\x58\x53\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");
NXSessionList::continueListSessionsAfterNxFrameBufferHandling ();setNextState (
"\x66\x69\x6e\x69\x73\x68");}sub handleNxFrameBufferStart{(my (@param)=$_[
(0x04bf+ 3133-0x10fc)]);(my (%parameters)=());if ((scalar (@param)eq 
(0x0b92+ 2256-0x1461))){((%parameters)=NXShell::urlParameter2Hash (
NXShell::getLastParameters ($_[(0x0586+ 5172-0x19ba)])));}else{((%parameters)=
@param);}NXShell::stopGetCommandStateMachine ();if (defined ($parameters{
"\x6f\x70\x74\x69\x6f\x6e"})){(my $option=$parameters{"\x6f\x70\x74\x69\x6f\x6e"
});(my $username=NXLogin::getCurrentUser ());(my $geometry=$parameters{
"\x67\x65\x6f\x6d\x65\x74\x72\x79"});setUsername ($username);setGeometry (
$geometry);Logger::debug (((((((
"\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x78\x73\x65\x72\x76\x65\x72\x73\x74\x61\x72\x74\x20\x77\x69\x74\x68\x20\x6f\x70\x74\x69\x6f\x6e\x20"
.$option)."\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20").$username).
"\x20\x77\x69\x74\x68\x20\x67\x65\x6f\x6d\x65\x74\x72\x79\x20").$geometry).
"\x2e"));if (($option eq "\x79\x65\x73")){setNextState (
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x52\x65\x63\x65\x69\x76\x65\x64"
);run ();return ((0x0c5b+ 6362-0x2535));}elsif (($option eq 
"\x61\x6c\x77\x61\x79\x73")){setNextState (
"\x73\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
);run ();return ((0x045a+ 8039-0x23c1));}}else{Logger::error (((
"\x57\x72\x6f\x6e\x67\x20\x78\x73\x65\x72\x76\x65\x72\x73\x74\x61\x72\x74\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x20"
.join ($",@param))."\x2e"));NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,"\x73\x65\x73\x73\x69\x6f\x6e");setNextState ("\x65\x72\x72\x6f\x72");run ();
return ((0x0ff1+ 4070-0x1fd7));}setNextState (
"\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
);run ();}sub handleRequestToStartNxFrameBuffer{(my $socket=shift (@_));(my $request
=shift (@_));Logger::debug (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x68\x61\x6e\x64\x6c\x69\x6e\x67\x20\x72\x65\x71\x75\x65\x73\x74\x20\x27"
.$request)."\x27\x2e"));(my $message=(""));if (($request=~ /Start virtual frame buffer username=(.*) geometry=(.*) connection=(.*)/ )
){(my $username=main::urldecode ($1));(my $geometry=main::urldecode ($2));(my $connection
=main::urldecode ($3));Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x63\x68\x65\x63\x6b\x69\x6e\x67\x20\x69\x66\x20\x73\x68\x6f\x75\x6c\x64\x20\x73\x74\x61\x72\x74\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x2e"
);(my ($requestCanBeHandled,$errorMessage)=checkRequestCouldBeHandled ());if (
$requestCanBeHandled){Logger::debug (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20"
.$username)."\x2e"));($errorMessage=(""));if (handleStartNxFrameBuffer (
$username,$geometry,$connection,(\$errorMessage))){($message=$message_started);}
else{if (($errorMessage ne (""))){($message=$errorMessage);}else{($message=
$message_errorStarting);}}}else{($message=$errorMessage);}}else{Logger::warning 
(((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x77\x72\x6f\x6e\x67\x20\x72\x65\x71\x75\x65\x73\x74\x20\x27"
.$request)."\x27\x2e"));($message=$message_abortedWrongRequest);}main::nxwrite (
$socket,$message);}sub checkRequestCouldBeHandled{if (
NXLocalSession::anyXserverFound ()){Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x3a\x20\x58\x73\x65\x72\x76\x65\x72\x20\x66\x6f\x75\x6e\x64\x2e"
);return ((0x1eda+ 123-0x1f55),$message_abortedXserverFound);}elsif (
checkIsAnyNxFrameBufferSessionsRunning ()){Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x3a\x20\x6f\x74\x68\x65\x72\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);return ((0x0bf7+ 5150-0x2015),$message_abortedFrameBufferRunning);}elsif ((not
 (NXLicense::isNxFrameBufferFeature ()))){Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x3a\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x2e"
);return ((0x001a+ 7634-0x1dec),$message_abortedFrameBufferDisabled);}else{
return ((0x0290+ 2148-0x0af3),(""));}}sub setNxFrameBufferRunning{(
$__nxFrameBufferRunning=shift (@_));}sub isNxFrameBufferRunning{if ((
$__nxFrameBufferRunning ne (""))){if (NXSession2::existSession (
$__nxFrameBufferRunning)){return ((0x0a66+ 139-0x0af0));}(
$__nxFrameBufferRunning=(""));}return ((0x0079+ 2613-0x0aae));}sub 
shouldStartNewXserver{if (isNxFrameBufferRunning ()){return (
(0x04a6+ 549-0x06cb));}if (NXLicense::isNxFrameBufferFeature ()){if ((
$GLOBAL::CreateDisplay==(0x11b7+ 1211-0x1671))){return ((0x14b2+ 2319-0x1dc0));}
return ((0x0801+ 1599-0x0e40));}else{return ((0x1210+ 1368-0x1768));}}sub 
handleStartNxFrameBuffer{(my $username=shift (@_));(my $geometry=shift (@_));(my $connection
=shift (@_));(my $ref_error=shift (@_));if (($username eq (""))){($username=
getUsername ());}if (($geometry eq (""))){($geometry=getGeometry ());}
Logger::debug (
"\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x6e\x65\x77\x20\x58\x73\x65\x72\x76\x65\x72\x2e"
);(my $sessionParameters=
NXSessionParameters::getParametersForNxFrameBufferServer ($username,$geometry));
(my $assignedDisplay=NXVirtualSession::startSessionForUserAndWaitForConnected (
$sessionParameters,$ref_error,$connection));if (($assignedDisplay!=(-
(0x1887+ 3603-0x2699)))){(my (@sessions)=NXSession2::getSessionIDsByDisplay (
$assignedDisplay));setNxFrameBufferRunning (@sessions[(0x07cb+ 4422-0x1911)]);
return ((0x23d7+ 143-0x2465));}else{Logger::error (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x66\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x73\x74\x61\x72\x74\x2e"
);if (($$ref_error ne (""))){Logger::error ((
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x65\x72\x72\x6f\x72\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x66\x72\x6f\x6d\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20"
.$$ref_error));}return ((0x05b5+ 3844-0x14b9));}}sub 
handleStartNxFrameBufferAutomatically{(my $username=getUsername ());(my $geometry
=getGeometry ());(my $connection=$defaultConnection);return (
handleStartNxFrameBuffer ($username,$geometry,$connection));}sub 
checkIsAnyNxFrameBufferSessionsRunning{(my (@sessions)=
NXSession2::getSessionsByType (Common::NXSessionType::getNXFrameBuffer ()));(my $count
=scalar (@sessions));if (($count>(0x050a+ 5144-0x1921))){Logger::warning ((
$count.
"\x20\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x73\x20\x61\x72\x65\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e\x20\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x73\x65\x73\x73\x69\x6f\x6e\x73\x2e"
));NXTerminate::terminateSpecified (keys (%sessions));return (
(0x0822+ 3498-0x15cb));}elsif (($count==(0x11f6+ 4320-0x22d5))){Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x20\x69\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);return ((0x0589+ 8367-0x2637));}else{Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);return ((0x0597+ 4266-0x1641));}}sub checkIsNxFrameBufferSessionsReady{(my (
@sessions)=NXSession2::getSessionsByType (
Common::NXSessionType::getNXFrameBuffer ()));foreach my $session (@sessions){if 
(NXSession2::sessionIsAliveByStatus (NXSession2::getStatusBySessionId ($session)
)){(my ($display,$cookie)=NXSession2::getAgentMDisplayAndCookieBySessionId (
$session));if (defined ($display)){Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x20\x69\x73\x20\x72\x65\x61\x64\x79\x2e"
);return ((0x0b60+ 3454-0x18dd));}return ((0x00dd+ 9419-0x25a8));}}}sub setError
{(my $error=shift (@_));($__error=$error);}sub getError{return ($__error);}sub 
setUsername{($__username=shift (@_));}sub setGeometry{($__geometry=shift (@_));}
sub getUsername{if ((defined ($__username)and ($__username ne ("")))){return (
$__username);}else{return ($GLOBAL::DisplayOwner);}}sub getGeometry{if ((defined
 ($__geometry)and ($__geometry ne ("")))){return ($__geometry);}elsif ((
$GLOBAL::DisplayGeometry eq (""))){return ("\x38\x30\x30\x78\x36\x30\x30");}else
{return ($GLOBAL::DisplayGeometry);}}sub clientNotAsked{return (
$__clientNotAsked);}sub setClientAsked{($__clientNotAsked=(0x1040+ 3047-0x1c27))
;}sub getMessageStarted{return ($message_started);}sub getMessageXserverFound{
return ($message_abortedXserverFound);}sub getMessageFrameBufferRunning{return (
$message_abortedFrameBufferRunning);}sub saveParametersInConfigFile{(my $username
=getUsername ());(my $geometry=getGeometry ());main::changeServerCfgKey (
"\x44\x69\x73\x70\x6c\x61\x79\x4f\x77\x6e\x65\x72",$username);
main::changeServerCfgKey (
"\x44\x69\x73\x70\x6c\x61\x79\x47\x65\x6f\x6d\x65\x74\x72\x79",$geometry);
main::changeServerCfgKey ("\x43\x72\x65\x61\x74\x65\x44\x69\x73\x70\x6c\x61\x79"
,(0x057c+ 478-0x0759));}sub initializeMessages{NXMsg::register_response (
"\x73\x65\x73\x73\x69\x6f\x6e",
"\x69\x43\x4d\x44\x41\x73\x6b\x49\x66\x43\x72\x65\x61\x74\x65\x58\x73\x65\x72\x76\x65\x72"
,(0x0631+ 772-0x08a0));NXMsg::register_response ("\x73\x65\x73\x73\x69\x6f\x6e",
"\x69\x43\x4d\x44\x58\x73\x65\x72\x76\x65\x72\x53\x74\x61\x72\x74\x65\x64",
(0x02f6+ 6259-0x1ad3));NXMsg::register_response ("\x73\x65\x73\x73\x69\x6f\x6e",
"\x69\x43\x4d\x44\x58\x73\x65\x72\x76\x65\x72\x4e\x6f\x74\x53\x74\x61\x72\x74\x65\x64\x58\x46\x6f\x75\x6e\x64"
,(0x1720+ 856-0x19e1));NXMsg::register_error ("\x73\x65\x73\x73\x69\x6f\x6e",
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,(0x035d+ 1874-0x08bb));NXMsg::register_error ("\x73\x65\x73\x73\x69\x6f\x6e",
"\x65\x47\x55\x49\x57\x72\x6f\x6e\x67\x58\x73\x65\x72\x76\x65\x72\x53\x74\x61\x72\x74\x43\x6f\x6d\x6d\x61\x6e\x64"
,(0x0874+ 3584-0x1480));}return ((0x0b11+ 2160-0x1380));
