############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXRedis::BEGIN{package NXRedis;no warnings;require NXMsg;do{
"\x4e\x58\x4d\x73\x67"->import};}package NXRedis;no warnings;$selector;
$readRedis;$writeRedis;$daemonRedis;$clientRedis;($retry=(0x1773+ 350-0x18d1));(
$connected=(0x18ad+ 132-0x1931));($serverInit=(0x0173+ 8789-0x23c8));(
$multiCommand=(0x0eb8+ 2333-0x17d5));($resendSuccess=(0x14cd+ 4579-0x26b0));(
$waitingConnect=(0x0b2b+ 2717-0x15c8));($lockFileHandle=(-(0x06c2+ 515-0x08c4)))
;($redisServerPid=(-(0x06d7+ 3464-0x145e)));($waitingForAcquireTimeout=
(0x06e3+ 7473-0x2360));($waitingForReleaseCounter=(0x1944+ 3373-0x2671));(
$waitingForNewDaemonCounter=(0x1508+ 1566-0x1b26));($waitingForReleaseSendKill=
(0x0676+ 4669-0x1895));($waitingForRedisDaemonReply=(0x08ab+ 4321-0x1989));(
$waitingForNonDaemonServerReleaseTimeout=(0x0bf5+ 769-0x0e92));(
$timeoutForNewDaemonWaiting=(0x1317+ 278-0x133d));($waitingForNewDaemonTick=0.5)
;($failCounter=(0x1ea5+ 1303-0x23bc));($finalizeProcessStarted=
(0x1fe8+ 439-0x219f));($doNotCloseRedisThreadsWhenFreePerl=(0x07bf+ 1111-0x0c16)
);($waitForResponseTimeout=(0x0a19+ 2120-0x1257));($waitIntervalTime=0.1);(
$maxWaitTimeout=(0x0d5f+ 1386-0x119d));@waitingCommandList;@responses;
@sendCommandList;($descriptorLimit=(0x2228+ 300-0x1354));(
$errorDuringLastCommand=(0x00c2+ 8229-0x20e7));sub initRedisServer{if ((
$serverInit==(0x130a+ 3976-0x2292))){(my $cookie=NXServerDaemon::getCookie ());
setNxDirInNXHomeDirOwner ();if (main::nxPipeCreateBi ((\$daemonRedis),(
\$clientRedis))){Logger::debug (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x72\x65\x61\x74\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x5b"
.$daemonRedis)."\x2f").$clientRedis)."\x5d\x2e"));}else{Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);return;}(my $returnValue=libnxhs::NXRedisServerCreate ($daemonRedis,$cookie,
NXPaths::getRedisDatabaseDirectory (),NXPaths::getNXErrorFile ()));if ((
$returnValue==(0x0976+ 1583-0x0fa4))){($serverInit=(0x00a7+ 8590-0x2234));
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x2e"
);Common::NXCore::doNotCloseSocketAtFinish ($daemonRedis);}else{Logger::error ((
(
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x69\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x20\x65\x72\x72\x6f\x72\x20\x77\x69\x74\x68\x20\x72\x65\x74\x75\x72\x6e\x20\x76\x61\x6c\x75\x65\x3a\x20"
.$returnValue)."\x2e"));(my $error=libnxh::NXGetErrorName ());(my $errorstring=
libnxh::NXGetErrorString ());Logger::error (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20".
$error)."\x3a\x20").$errorstring)."\x2e"));main::nxexit ();}}elsif ((not (
checkRedisFlock ()))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x73\x65\x72\x76\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x6f\x6e\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);removeRedisServerLockFileHandle ();}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x73\x65\x72\x76\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x6f\x6e\x20\x74\x68\x69\x73\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);}}sub auth{my ($cookie);if (($serverInit==(0x07c2+ 4452-0x1926))){($cookie=
NXClientSystemDaemons::getCookieForRedisAuthentication ());}else{($cookie=
NXServerDaemon::getCookie ());}if (($cookie ne (""))){sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x61\x75\x74\x68\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d"
.$cookie)."\x0a"));(my $returnValue=get ());if (($returnValue ne "\x4f\x4b")){
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x41\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x72\x65\x74\x75\x72\x6e\x20\x76\x61\x6c\x75\x65\x3a\x20"
.$returnValue)."\x2e"));forceCloseRedisClient ();checkFailCounter ();return (
(0x003c+ 9336-0x24b3));}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x64\x2e"
);($failCounter=(0x0b30+ 2063-0x133f));return ((0x079b+ 6597-0x2160));}}else{
forceCloseRedisClient ();checkFailCounter ();Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x41\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x69\x6f\x6e\x20\x63\x6f\x6f\x6b\x69\x65\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2c\x20\x63\x61\x6e\x6e\x6f\x74\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((0x1e48+ 1784-0x253f));}}sub initRedisClient{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x49\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);if ((($readRedis eq (""))or ($writeRedis eq ("")))){if (
libnxhs::NXRedisClientRunning ()){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x72\x65\x61\x74\x65\x64\x2e"
);Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x53\x75\x62\x73\x79\x73\x74\x65\x6d\x47\x65\x74\x52\x65\x64\x69\x73\x46\x64\x28\x29"
);(my $FD=libnxhs::NXSubsystemGetRedisFd ());Logger::debug2 (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x53\x75\x62\x73\x79\x73\x74\x65\x6d\x47\x65\x74\x52\x65\x64\x69\x73\x46\x64\x28\x29\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$FD)."\x27\x2e"));if (($FD>=(0x1206+ 1102-0x1654))){($connected=
(0x0909+ 4819-0x1bdb));($readRedis=$FD);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x69\x6e\x68\x65\x72\x69\x74\x65\x64\x20\x46\x44\x23"
.$FD)."\x2e"));($selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;$selector->add ($readRedis);$selector->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});}else{Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x52\x65\x64\x69\x73\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x2e"
);}if (checkIfSubscriptionShouldBeStarted ()){main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::createSubscriptionClient ();}return;}if ((not (
main::nxPipeCreateBi ((\$readRedis),(\$writeRedis))))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);return ((0x14b1+ 2969-0x204a));}(my $homeDir=NXPaths::getUserNXHomeDir ());
libnxh::NXTransSetEnvironment ("\x48\x4f\x4d\x45",$homeDir);Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x72\x65\x61\x74\x65\x28"
.$writeRedis)."\x2c\x20").$writeRedis)."\x29"));(my $rettmp=
libnxhs::NXRedisCreate ($writeRedis,$writeRedis));Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x72\x65\x61\x74\x65\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$rettmp)."\x27\x2e"));Common::NXCore::doNotCloseSocketAtFinish ($writeRedis);}(
$selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;$selector->add ($readRedis);$selector->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});if (($serverInit==(0x0e0c+ 5686-0x2442))){if ((
NXClientSystemDaemons::openConnection ((0x057a+ 8520-0x26c1))!=
(0x1154+ 5298-0x2605))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x0a4a+ 5719-0x20a1));}if (main::nxPipeCreateBi ((\$daemonRedis),(
\$clientRedis))){Logger::debug (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x72\x65\x61\x74\x65\x64\x20\x73\x65\x63\x6f\x6e\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x5b"
.$daemonRedis)."\x2f").$clientRedis)."\x5d\x2e"));}else{Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x73\x65\x63\x6f\x6e\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);return ((0x075f+ 3372-0x148b));}(my $socketCookie=main::get_unique_id ());(my $tmpDir
=NXPaths::getTmpDir ());(my $socketPath=(($tmpDir.$GLOBAL::DIRECTORY_SLASH).
main::get_unique_id ()));(my $message=(("\x4e\x58\x3e\x20".
$GLOBAL::MSG_REDIS_YIELD)."\x20\x52\x65\x64\x69\x73\x20\x79\x69\x65\x6c\x64"));(
$message.=("\x20\x70\x69\x64\x3d".$ $));
 ($message.=(
"\x20\x73\x6f\x63\x6b\x65\x74\x50\x61\x74\x68\x45\x6e\x63\x6f\x64\x65\x64\x3d".
main::urlencode ($socketPath)));($message.=(
"\x20\x73\x6f\x63\x6b\x65\x74\x43\x6f\x6f\x6b\x69\x65\x3d".$socketCookie));(
$message.=("\x20\x66\x64\x3d".$daemonRedis));($message.="\x20\x0a");if ((
NXClientSystemDaemons::sendMessage ($message)!=(0x0e59+ 2511-0x1827))){
Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x16a7+ 1324-0x1bd3));}Server::saveTimestamp (
"\x72\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x41\x63\x71\x75\x69\x72\x65",
"\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x63\x71\x75\x69\x72\x65\x2e"
);(my $response=NXClientSystemDaemons::getDaemonReplyAboutRedis (
$waitingForAcquireTimeout));if (($response ne getMessageStartAcquire ())){if ((
$response eq (""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x74\x69\x6d\x65\x6f\x75\x74\x3a\x20"
.$waitingForAcquireTimeout)."\x20\x72\x65\x61\x63\x68\x65\x64\x2e"));}else{
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x72\x65\x61\x64\x79\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20"
.$response)."\x2e"));}NXClientSystemDaemons::closeConnection ();return (
(0x0090+ 1077-0x04c5));}if ((Common::NXDescriptor::yield ($daemonRedis,
$socketPath,$socketCookie)==(-(0x0643+ 2820-0x1146)))){Logger::error (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x79\x69\x65\x6c\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x46\x44\x23"
.$daemonRedis).
"\x20\x77\x69\x74\x68\x20\x73\x6f\x63\x6b\x65\x74\x20\x70\x61\x74\x68\x20").
$socketPath)."\x2e"));NXClientSystemDaemons::closeConnection ();main::nxexit (
(0x1978+ 2225-0x2228));}($response=(""));($response=
NXClientSystemDaemons::getDaemonReplyAboutRedis ($waitingForRedisDaemonReply));
if (($response eq getMessageAcquireFail ())){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x66\x61\x69\x6c\x65\x64\x2e"
);NXClientSystemDaemons::closeConnection ();main::nxexit ((0x162a+ 1253-0x1b0e))
;}if (($response ne getMessageAcquireDone ())){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x64\x75\x72\x69\x6e\x67\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x3a\x20"
.$response)."\x2e"));NXClientSystemDaemons::closeConnection ();return (
(0x0b15+ 7051-0x26a0));}Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4e\x58\x52\x65\x64\x69\x73\x41\x63\x71\x75\x69\x72\x65\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x66\x74\x65\x72\x20"
.Server::getTimePassedFromSavedTimestamp (
"\x72\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x41\x63\x71\x75\x69\x72\x65")).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));
Common::NXCore::doNotCloseSocketAtFinish ($daemonRedis);
NXClientSystemDaemons::closeConnection ();Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x70\x61\x73\x73\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x74\x6f\x20\x74\x68\x65\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);}($connected=(0x0b57+ 5225-0x1fbf));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6f\x6e\x6e\x65\x63\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x66\x64\x3d"
.$clientRedis)."\x0a"));if ((get ()eq "\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64")){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e"
);Common::NXCore::doNotCloseSocketAtFinish ($clientRedis);if ((auth ()==
(0x0929+ 5319-0x1def))){return (initRedisClient ());}($redisServerPid=
__getRedisServerPid ());if (($serverInit==(0x071f+ 5272-0x1bb6))){
main::nxrequire ("\x4e\x58\x52\x65\x64\x69\x73\x53\x63\x72\x69\x70\x74");
NXRedisScript::loadAllScriptsToDb ();}if (checkIfSubscriptionShouldBeStarted ())
{main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::createSubscriptionClient ();}}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e"
);}}sub sendToDb{(my $msg=shift (@_));if ((Server::isDaemonProcess ()and (
$serverInit==(0x099d+ 4556-0x1b69)))){if ((
NXServerDaemon::checkAndSetServerDaemonFlock ()==(0x11f3+ 1632-0x1853))){
Logger::error (
"\x41\x6e\x6f\x74\x68\x65\x72\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x69\x6e\x73\x74\x61\x6e\x63\x65\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);main::nxexit ();}main::nxrequire (
"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73");if (
NXSystemDaemons::savePid ("\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 Logger::error
 (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x61\x76\x65\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x70\x69\x64\x2e"
);main::nxexit ();}if ((__checkAndSetRedisServerFlock ()==(0x1822+ 316-0x195d)))
{initRedisServer ();($waitingForReleaseCounter=(0x0fb9+ 2637-0x1a06));}else{if (
($waitingForReleaseCounter>$waitingForReleaseSendKill)){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e\x20\x45\x78\x69\x74\x69\x6e\x67\x2e"
);main::nxexit ((0x2066+ 1305-0x257f));}if (($waitingForReleaseCounter==
$waitingForReleaseSendKill)){(my $redisServerPid=__getRedisServerPid ());
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x6b\x69\x6c\x6c\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$redisServerPid).
"\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
));__killOtherRedisServer ($redisServerPid);}Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4f\x74\x68\x65\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x69\x73\x20\x63\x75\x72\x72\x65\x6e\x74\x6c\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);main::nxsleep (0.5);(++$waitingForReleaseCounter);return (sendToDb ($msg));}}
main::nxrequire ("\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73")
;if ((((((($connected==(0x16c7+ 4028-0x2683))and (
NXSystemDaemons::isShutdownFlag ()==(0x1a1a+ 1528-0x2012)))and ($redisServerPid
!=(-(0x124f+ 4664-0x2486))))and ($serverInit==(0x072d+ 527-0x093c)))and (
NXServerDaemon::checkDaemonFlock ()==(0x1056+  91-0x10b0)))and (
$finalizeProcessStarted==(0x006c+ 995-0x044f)))){(++$waitingForNewDaemonCounter)
;main::nxsleep ($waitingForNewDaemonTick);if (($waitingForNewDaemonCounter>=
$timeoutForNewDaemonWaiting)){($redisServerPid=(-(0x1ba1+ 2570-0x25aa)));(my $logTimeout
=($waitingForNewDaemonCounter *$waitingForNewDaemonTick));(
$waitingForNewDaemonCounter=(0x08fc+ 5000-0x1c84));Logger::error (((
"\x53\x65\x72\x76\x65\x72\x20\x6c\x6f\x73\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x61\x6e\x64\x20\x74\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x6e\x65\x77\x20\x6f\x6e\x65\x20"
.$logTimeout).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x20\x72\x65\x61\x63\x68\x65\x64\x2e"));closeDb
 ((0x0232+ 6715-0x1c6c));main::nxexit ((0x0522+ 6768-0x1f91));}else{return (
sendToDb ($msg));}}($waitingForNewDaemonCounter=(0x1130+ 2360-0x1a68));if ((((
$connected==(0x0731+ 4890-0x1a4b))and ($serverInit==(0x08aa+ 5365-0x1d9f)))and (
not (Server::isDaemonProcess ())))){if ((NXSystemDaemons::isShutdownFlag ()==
(0x0e9f+ 1968-0x164e))){if ((__checkAndSetRedisServerFlock ()==
(0x1081+ 1927-0x1807))){initRedisServer ();($waitingForReleaseCounter=
(0x12c8+ 1231-0x1797));}else{removeRedisServerLockFileHandle ();if ((
$waitingForReleaseCounter==$waitingForNonDaemonServerReleaseTimeout)){
Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x6f\x6e\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e"
);return ((0x009f+ 8293-0x2104));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x6f\x6e\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x2e\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x62\x75\x74\x20\x74\x68\x65\x72\x65\x20\x69\x73\x20\x6c\x6f\x63\x6b\x20\x6f\x6e\x20\x66\x69\x6c\x65\x2e"
);main::nxsleep ($waitIntervalTime);(++$waitingForReleaseCounter);return (
sendToDb ($msg));}}elsif ((NXServerDaemon::checkDaemonFlock ()==
(0x0805+ 7692-0x2610))){if ((($GLOBAL::isNXServerLoginProcess==
(0x1248+ 3482-0x1fe2))or (($GLOBAL::isNXServerLoginProcess==
(0x1001+ 5020-0x239c))and ($finalizeProcessStarted==(0x1228+ 3349-0x1f3c))))){if
 ((__checkAndSetRedisServerFlock ()==(0x105f+ 1053-0x147b))){initRedisServer ();
($waitingForReleaseCounter=(0x16ab+ 310-0x17e1));}else{
removeRedisServerLockFileHandle ();if (($waitingForReleaseCounter==
$waitingForNonDaemonServerReleaseTimeout)){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e"
);return ((0x075a+ 1330-0x0c8c));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x62\x75\x74\x20\x74\x68\x65\x72\x65\x20\x69\x73\x20\x6c\x6f\x63\x6b\x20\x6f\x6e\x20\x66\x69\x6c\x65\x2e"
);main::nxsleep ($waitIntervalTime);(++$waitingForReleaseCounter);return (
sendToDb ($msg));}}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x61\x73\x20\x6c\x6f\x67\x69\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);checkFailCounter ();return ((0x047b+ 7656-0x2263));}}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);}}if (($connected==(0x1b66+ 1073-0x1f97))){initRedisClient ();}if (($connected
==(0x0e0c+ 3881-0x1d35))){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$msg).
"\x27\x2e\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e"
));return ((0x0cf7+ 4727-0x1f6e));}if ((__checkCommandLine ((\$msg))==
(0x0285+ 4262-0x132a))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$msg)."\x27\x20\x61\x62\x6f\x72\x74\x65\x64\x2e"));return (
(0x0e08+ 5216-0x2268));}Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x27".$msg)
."\x27\x2e"));if ((main::nxwrite ($readRedis,$msg)==(-(0x1086+ 819-0x13b8)))){if
 (($retry==(0x00dd+ 6960-0x1c0d))){closeDb ();($retry=(0x1b21+ 2343-0x2447));
sendToDb ($msg);}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$msg).
"\x27\x2e\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e"
));return ((0x0d83+ 2841-0x189c));}}($retry=(0x10f0+ 1804-0x17fc));push (
@sendCommandList,$msg);return ((0x155d+ 3699-0x23cf));}sub sendToDbAndSave{(my $msg
=shift (@_));if ((sendToDb ($msg)==(0x09dc+ 4288-0x1a9b))){saveDb ();}}sub 
sendToDbAndGetReply{(my $request=shift (@_));if ((sendToDb ($request)==
(0x2210+ 528-0x241f))){return (split ( / / ,get (),(0x1f97+ 1694-0x2635)));}
return (undef);}sub readFromDb{my ($read_buf);(my $bytes_read=main::nxread (
$readRedis,(\$read_buf),32768));if ((($bytes_read eq (0x0806+ 5400-0x1d1e))or (
$bytes_read eq ("")))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x0d74+ 166-0x0e1a));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x63\x65\x69\x76\x65\x64\x20\x64\x61\x74\x61\x20\x6f\x6e\x20\x52\x65\x64\x69\x73\x20\x73\x6f\x63\x6b\x65\x74\x3a\x20\x27"
.$response)."\x27\x2e"));parseRedisOutput ($response);}}sub get{(my $callbackTimeout
=(shift (@_)||(0x01f1+ 922-0x058b)));(my $ref_timeoutCallback=shift (@_));if ((
$sendCommandList[-(0x1646+ 1169-0x1ad6)]eq (""))){return ((""));}push (
@waitingCommandList,$sendCommandList[-(0x0969+ 6916-0x246c)]);(my $tmpLastCommand
=__getCommandNameFromLine ($sendCommandList[-(0x18d5+ 2677-0x2349)]));my (
$returnValue);if ((waitForReponse ($callbackTimeout,$ref_timeoutCallback)==
(0x12ba+   2-0x12bb))){($returnValue=pop (@responses));($failCounter=
(0x0b14+ 5313-0x1fd5));Logger::debug3 (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x27"
.$tmpLastCommand)."\x27\x20\x69\x73\x20\x27").$returnValue)."\x27\x2e"));}else{
if ((checkFailure ()==(0x0cd5+ 991-0x10b4))){if ((waitForReponse (
$callbackTimeout,$ref_timeoutCallback)==(0x1770+ 882-0x1ae1))){($returnValue=pop
 (@responses));($failCounter=(0x19b6+ 3403-0x2701));Logger::debug3 (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x27"
.$tmpLastCommand)."\x27\x20\x69\x73\x20\x27").$returnValue)."\x27\x2e"));}else{(
@waitingCommandList=());(@responses=());shift (@sendCommandList);Logger::error (
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x75\x74\x70\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$tmpLastCommand).
"\x20\x61\x66\x74\x65\x72\x20\x72\x65\x73\x65\x6e\x64\x69\x6e\x67\x2e"));}}else{
Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x75\x74\x70\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$tmpLastCommand).
"\x20\x52\x65\x73\x65\x6e\x64\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x73\x20\x66\x61\x69\x6c\x65\x64\x2e"
));}}return ($returnValue);}sub getWithCallbackOnTimeout{(my $callbackTimeout=
shift (@_));(my $ref_timeoutCallback=shift (@_));if (($maxWaitTimeout<
$callbackTimeout)){return (get ());}(my $defaultTimeout=$waitForResponseTimeout)
;($waitForResponseTimeout=$maxWaitTimeout);(my $result=get ($callbackTimeout,
$ref_timeoutCallback));($waitForResponseTimeout=$defaultTimeout);return ($result
);}sub waitForReponse{(my $callbackTimeout=(shift (@_)||(0x00d9+ 5657-0x16f2)));
(my $ref_timeoutCallback=shift (@_));(my $waitTime=(0x15d7+ 1139-0x1a4a));(my $waitForResponseTimeout
=($waitForResponseTimeout *(0x04b9+ 8251-0x210c)));(my $maxSelectTimeout=
$waitForResponseTimeout);if ($callbackTimeout){($maxSelectTimeout=
$callbackTimeout);}if (((__getCommandNameFromLine ($waitingCommandList[
(0x1758+ 3868-0x2674)])eq "\x61\x75\x74\x68")or (__getCommandNameFromLine (
$waitingCommandList[(0x07e3+ 1186-0x0c85)])eq "\x65\x76\x61\x6c\x73\x68\x61"))){
($waitForResponseTimeout=(($NXRedis::waitForResponseTimeout *
(0x0473+ 5736-0x16f3))*(0x0ff9+ 4976-0x2363)));($maxSelectTimeout=
$waitForResponseTimeout);}($selectTimeout=$maxSelectTimeout);(my $startTime=
Common::NXTime::getMillisecondsSinceEpoch ());(my $lastTimeoutCallbackCall=
(0x09f6+ 1539-0x0ff9));while (((@waitingCommandList and ($waitTime<
$waitForResponseTimeout))and (($connected==(0x0f65+ 2688-0x19e4))||(
__getCommandNameFromLine ($waitingCommandList[(0x05a2+ 4182-0x15f8)])eq 
"\x63\x6f\x6e\x6e\x65\x63\x74")))){(my (@ready)=$selector->can_read (
$selectTimeout));foreach my $fh (@ready){if (($fh eq $readRedis)){if (
@waitingCommandList){readFromDb ();}}}if (@waitingCommandList){if ((
$resendSuccess==(0x0372+ 8746-0x259b))){($waitTime=(0x01f0+ 6015-0x196f));(
$selectTimeout=$maxSelectTimeout);($startTime=
Common::NXTime::getMillisecondsSinceEpoch ());($resendSuccess=
(0x1082+ 4513-0x2223));}else{($waitTime=(
Common::NXTime::getMillisecondsSinceEpoch ()-$startTime));if ($callbackTimeout){
if ((($waitTime+$selectTimeout)>$waitForResponseTimeout)){($selectTimeout=(
$waitForResponseTimeout-$waitTime));}}else{($selectTimeout=($maxSelectTimeout-
$waitTime));}}if ($callbackTimeout){if ((($lastTimeoutCallbackCall+
$callbackTimeout)<Common::NXTime::getSecondsSinceEpoch ())){&{
$ref_timeoutCallback;}();($lastTimeoutCallbackCall=
Common::NXTime::getSecondsSinceEpoch ());}}}}if (($connected!=
(0x1915+ 937-0x1cbd))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x69\x65\x6e\x74\x20\x77\x61\x73\x20\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2c\x20\x71\x75\x69\x74\x20\x77\x61\x69\x74\x69\x6e\x67\x2e"
);return ((0x2588+ 289-0x26a9));}if (@waitingCommandList){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x54\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.__getCommandNameFromLine ($waitingCommandList[(0x05c6+ 2207-0x0e65)])).((
"\x20\x77\x68\x69\x63\x68\x20\x69\x73\x20".$NXRedis::waitForResponseTimeout).
"\x20\x68\x61\x73\x20\x62\x65\x65\x6e\x20\x72\x65\x61\x63\x68\x65\x64\x2e")));
checkFailCounterAndCloseIfNeeded ();return ((0x042b+ 5988-0x1b8f));}return (
(0x0284+ 9080-0x25fb));}sub parseRedisOutput{(my $output=shift (@_));($output.=
"\x20");(my (@lines)=split ( /\n/ ,$output,(0x0bf6+ 1333-0x112b)));while (@lines
){(my $line=shift (@lines));if (($line=~ /event=disconnected,error=0/ )){(
$connected=(0x174d+ 2262-0x2023));next;}(my $response=shift (@lines));unless (
@sendCommandList){return;}my ($firstWaitingCommand);if (@waitingCommandList){(
$firstWaitingCommand=__getCommandNameFromLine ($waitingCommandList[
(0x206d+ 519-0x2274)]));}if ((handleCommandSuccesful ($line)==
(0x118a+ 412-0x1325))){return;}if (($line=~ /command=connect,error=0/ )){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e");
($connected=(0x0694+ 5480-0x1bfb));shift (@waitingCommandList);push (@responses,
"\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");next;}elsif (($line=~ /command=connect,error=/ )
){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x2e"
);shift (@waitingCommandList);push (@responses,
"\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");($connected=
(0x15bf+ 1968-0x1d6f));next;}elsif ((($line=~ /command=(.*),error=0/ )and (
$response ne ("")))){(my $command=$1);if (($command eq $firstWaitingCommand)){(my $fullResponse
=$response);if (($command eq "\x63\x6c\x69\x65\x6e\x74")){while ((@lines and (
$lines[(0x0417+ 2283-0x0d02)]=~ /^id=/ ))){($fullResponse.=("\x0a".shift (@lines
)));}}push (@responses,$fullResponse);shift (@waitingCommandList);next;}else{
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$firstWaitingCommand)."\x2e"));}}elsif ((($line=~ /command=(.*),error=0,size=0/ )
and ($response eq ("")))){(my $command=$1);if (($command eq $firstWaitingCommand
)){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6e\x6f\x20\x76\x61\x6c\x75\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.__getCommandNameFromLine ($waitingCommandList[(0x018a+ 4351-0x1289)])).
"\x20\x73\x61\x76\x65\x64\x20\x69\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"))
;push (@responses,(""));shift (@waitingCommandList);next;}else{Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$firstWaitingCommand)."\x2e"));}}elsif ((($line=~ /command=bgsave,error=1/ )and
 ($response=~ /ERR Background save already in progress/ ))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x61\x76\x69\x6e\x67\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x69\x6e\x20\x70\x72\x6f\x67\x72\x65\x73\x73\x2c\x20\x73\x6b\x69\x70\x69\x6e\x67\x2e"
);push (@responses,(""));shift (@waitingCommandList);shift (@sendCommandList);
next;}elsif (($line=~ /command=(.*),error=(.*)/ )){(my $error=$2);(
$errorDuringLastCommand=(0x1686+ 1138-0x1af7));if (($error ne (""))){if ((
__handleRedisErrorIfPossible ($response)==(0x0505+ 2647-0x0f5b))){return;}
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x27".
__getCommandNameFromLine ($sendCommandList[(0x05dd+ 2102-0x0e13)])).((((
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x20\x72\x65\x64\x69\x73\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$error)."\x3a\x20").$response).
"\x20\x4d\x6f\x72\x65\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x20\x69\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x2e"
)));}else{Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x27".
__getCommandNameFromLine ($sendCommandList[(0x03ca+ 717-0x0697)])).
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x20\x72\x65\x64\x69\x73\x2e\x20\x4d\x6f\x72\x65\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x20\x69\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x2e"
));}($connected=(0x058c+ 4746-0x1816));}elsif (($line eq (""))){next;}elsif ((
$response=~ /event=disconnected,error=0/ )){($connected=(0x00a0+ 7835-0x1f3b));
next;}}}sub getRedisDescriptor{return ($readRedis);}sub saveDb{Logger::debug (
"\x53\x61\x76\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);if (($serverInit==(0x0558+ 4562-0x1729))){sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x61\x76\x65\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}else{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x62\x67\x73\x61\x76\x65\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}(my $saveResponse=get ());}sub closeDb{(my $finalizeProcess=(shift (@_)||
(0x039c+ 2123-0x0be7)));if (($finalizeProcess==(0x0781+ 6845-0x223d))){(
$finalizeProcessStarted=(0x09ec+ 6187-0x2216));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x64\x62\x2e"
);while ((scalar (@sendCommandList)>(0x11b8+ 819-0x14eb))){(my $command=
__getCommandNameFromLine ($sendCommandList[(0x04af+ 2677-0x0f24)]));
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$command).
"\x27\x20\x62\x65\x66\x6f\x72\x65\x20\x63\x6c\x6f\x73\x69\x6e\x67\x2e"));get ();
}if (($doNotCloseRedisThreadsWhenFreePerl==(0x0127+ 8290-0x2188))){Logger::debug
 (
"\x4c\x65\x61\x76\x69\x6e\x67\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x6e\x64\x20\x72\x65\x64\x69\x73\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x74\x68\x72\x65\x61\x64\x2e"
);return;}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::closeSubscription ();if (($connected==(0x0a85+ 2613-0x14b9)
)){Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x44\x65\x73\x74\x72\x6f\x79\x28\x29"
);(my $returnValue=libnxhs::NXRedisClientDestroy ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x44\x65\x73\x74\x72\x6f\x79\x28\x29\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$returnValue)."\x27\x2e"));Common::NXSelector::removeFromGlobalSelector (
$readRedis);($readRedis=(""));($connected=(0x0e44+ 3943-0x1dab));}if ((
$serverInit==(0x04b8+ 8639-0x2676))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);if ((libnxhs::NXRedisServerDestroy ()==(0x0064+ 3529-0x0e2c))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);removeRedisServerLockFileHandle ();(my $redisLock=getRedisLockFile ());if ((
not (unlink ($redisLock)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}(my $redisPidFile=getRedisPidFile ());if ((not (
unlink ($redisPidFile)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}(my $dbFile=NXPaths::getRedisDatabaseFile ());if 
(Common::NXFile::fileExists ($dbFile)){my ($errorMsg);if ((
Common::NXFile::setOwnershipForUserNX ($dbFile,(\$errorMsg))==(-
(0x1c27+ 1712-0x22d6)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x72\x65\x64\x69\x73\x20\x66\x69\x6c\x65\x20\x27"
.$dbFile)."\x27\x20").$errorMsg)."\x2e"));}}}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x63\x6c\x6f\x73\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);}($serverInit=(0x0036+ 3659-0x0e81));}}sub isRedisDatabaseInit{if (
Server::isDaemonProcess ()){if (($serverInit==(0x15e7+ 2893-0x2133))){return (
(0x0f49+ 2628-0x198c));}else{return ((0x2128+ 1409-0x26a9));}}if (
isRedisLockFileExist ()){return ((0x120b+ 380-0x1386));}else{return (
(0x07d2+ 7284-0x2446));}}sub getRedisLockFile{(my $redisLockFile=((((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x64\x62").$GLOBAL::DIRECTORY_SLASH
)."\x73\x65\x72\x76\x65\x72").$GLOBAL::DIRECTORY_SLASH)."\x72\x65\x64\x69\x73"))
;return ($redisLockFile);}sub getRedisPidFile{(my $redisPidFile=((((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x64\x62").$GLOBAL::DIRECTORY_SLASH
)."\x73\x65\x72\x76\x65\x72").$GLOBAL::DIRECTORY_SLASH).
"\x72\x65\x64\x69\x73\x2e\x70\x69\x64"));return ($redisPidFile);}sub 
isRedisLockFileExist{(my $file=getRedisLockFile ());if (
Common::NXFile::fileExists ($file)){return ((0x00ba+ 9764-0x26dd));}else{return 
((0x0490+ 2651-0x0eeb));}}sub isNotRedisDatabaseInit{return ((!
isRedisDatabaseInit ()));}sub daemonAcquire{(my $message=shift (@_));(my $socket
=shift (@_));(my (%parameters)=());(my $redisDescriptor=(-(0x05bd+ 6595-0x1f7f))
);if (($serverInit==(0x11cd+ 804-0x14f1))){return ((0x0723+ 5394-0x1c34));}if ((
$message=~ /Redis yield/ )){($message=~ s/Redis yield // );(my (@args)=split ( / / ,
$message,(0x09b0+ 2708-0x1444)));foreach my $pair (@args){(my ($key,$value)=
split ( /=/ ,$pair,(0x1aa8+ 407-0x1c3c)));($parameters{$key}=$value);}(my $socketPath
=main::urldecode ($parameters{
"\x73\x6f\x63\x6b\x65\x74\x50\x61\x74\x68\x45\x6e\x63\x6f\x64\x65\x64"}));(my $msg
=getMessageStartAcquire ());if ((main::nxwrite ($socket,$msg)==(-
(0x0d1a+ 4279-0x1dd0)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x72\x65\x61\x64\x79\x2e"
));return ((0x23d7+  88-0x242e));}($redisDescriptor=
Common::NXDescriptor::acquire ($parameters{"\x70\x69\x64"},$parameters{
"\x66\x64"},$socketPath,$parameters{
"\x73\x6f\x63\x6b\x65\x74\x43\x6f\x6f\x6b\x69\x65"}));if ((($redisDescriptor<
(0x082c+ 3244-0x14d8))or ($redisDescriptor>$descriptorLimit))){Logger::warning (
((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x66\x72\x6f\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"})."\x20\x61\x6e\x64\x20").$socketPath)."\x2e"));(
$msg=getMessageAcquireFail ());if ((main::nxwrite ($socket,$msg)==(-
(0x0a8c+ 995-0x0e6e)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x66\x61\x69\x6c\x2e"
));}return ((0x0ca7+ 3054-0x1894));}Common::NXCore::doNotCloseSocketAtFinish (
$redisDescriptor);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x72\x65\x63\x65\x69\x76\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x46\x44\x23"
.$redisDescriptor)."\x20\x66\x72\x6f\x6d\x20\x73\x65\x72\x76\x65\x72\x2e"));(my $return
=libnxhs::NXRedisServerConnection ($redisDescriptor));Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x28"
.$redisDescriptor)."\x29\x20").$return)."\x2e"));($msg=getMessageAcquireDone ())
;if ((main::nxwrite ($socket,$msg)==(-(0x0408+ 1287-0x090e)))){Logger::warning (
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x6f\x6e\x65\x2e"
));}return ((0x122b+ 3680-0x208b));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x68\x61\x6e\x64\x6c\x65\x20\x72\x65\x64\x69\x73\x20\x79\x69\x65\x6c\x64\x20\x72\x65\x71\x75\x65\x73\x74\x3a\x20"
.$message)."\x2e"));return ((0x1648+ 221-0x1724));}}sub 
isDbRunningInCurrentProcess{return ($serverInit);}sub __lockFile{(my $file=
getRedisLockFile ());my ($errormsg);(my $SERVER_FH=main::nxopen ($file,(
$NXBits::O_WRONLY+$NXBits::O_CREAT),(($NXBits::UserReadWrite+$NXBits::GroupRead)
+$NXBits::OthersRead)));if ((not (defined ($SERVER_FH)))){(my $serverDir=
Common::NXFile::dirname ($file));if ((Common::NXFile::directoryExists (
$serverDir)==(0x0569+ 7225-0x21a2))){my ($errorMessage);if (
Common::NXPaths::makePath ((\$errorMessage),$serverDir)){if ((
Common::NXFile::setOwnershipForUserNX ($serverDir,(\$errorMessage))==(-
(0x156c+ 4041-0x2534)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x4e\x58\x20\x66\x6f\x72\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}if ((Common::NXFile::setPermissionsFullForNXDirectory ($serverDir,(
\$errorMessage))==(-(0x05f0+ 8159-0x25ce)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20\x4e\x58\x20\x66\x6f\x72\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}($SERVER_FH=main::nxopen ($file,($NXBits::O_WRONLY+$NXBits::O_CREAT),(
($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)));}else{
Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}}if ((not (defined ($SERVER_FH)))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x20\x66\x6f\x72\x20\x77\x72\x69\x74\x69\x6e\x67\x2e"));return ((-
(0x115d+ 4607-0x235b)));}}unless (main::nxflock ($SERVER_FH,$NXBits::LOCK_EX)){
Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x3a\x20"
.$file)."\x2e"));return ((-(0x0927+ 4560-0x1af6)));}
Common::NXFile::setOwnershipForUserNX ($file,(\$errormsg));if (($errormsg ne 
(""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errormsg)."\x2e"));}libnxh::NXDescriptorInheritable ($SERVER_FH,
(0x0583+ 794-0x089d));main::closeSocketAtFinish ($SERVER_FH);return ($SERVER_FH)
;}sub __checkAndSetRedisServerFlock{if (($serverInit==(0x11e2+ 1123-0x1644))){
return ((0x1329+ 1207-0x17e0));}if ((not (checkRedisFlock ()))){return (
(0x1457+ 2748-0x1f13));}else{unless ((main::effectiveUserIsAdministrator ()or (
Common::NXCore::getEffectiveUsername ()eq "\x6e\x78"))){if ((
NXSystemDaemons::isShutdownFlag ()==(0x0241+ 6379-0x1b2b))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x69\x6e\x75\x65\x2c\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x69\x73\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x20\x61\x6e\x64\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6f\x70\x65\x72\x61\x74\x69\x6f\x6e\x20\x72\x65\x71\x75\x69\x72\x65\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4e\x78\x73\x65\x72\x76\x65\x72\x53\x68\x75\x74\x64\x6f\x77\x6e"
,"\x4e\x58\x52\x65\x64\x69\x73");main::nxexit ((0x1c30+ 1896-0x2398));}}(my $file
=getRedisLockFile ());unlink ($file);(my $fh=__lockFile ());if (($fh==(-
(0x01e6+ 796-0x0501)))){return ((0x1281+ 2164-0x1af5));}
setRedisServerLockFileHandle ($fh);saveRedisPid ();return ((0x0ef4+ 3440-0x1c63)
);}}sub checkRedisFlock{if (($serverInit==(0x00ff+ 9057-0x245f))){return (
(0x144a+ 597-0x169f));}(my $file=getRedisLockFile ());Logger::debug (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x66\x69\x6c\x65\x20\x6c\x6f\x63\x6b\x3a\x20"
.$file)."\x2e"));if ((Common::NXFile::fileExists ($file)==(0x238b+ 872-0x26f3)))
{Logger::debug ((("\x46\x69\x6c\x65\x20".$file).
"\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));return (
(0x0db7+ 1059-0x11d9));}(my $SERVER_FH=main::nxopen ($file,$NXBits::O_RDONLY,
(0x07a5+ 7324-0x2441)));if ((not (defined ($SERVER_FH)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x3a\x20".$file
)."\x2e"));return ((0x072d+ 5924-0x1e51));}if ((not (Common::NXCore::nxTryLock (
$SERVER_FH,$NXBits::LOCK_EX)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x3a\x20".$file
)."\x2e"));main::nxclose ($SERVER_FH);if ((not (Server::isDaemonProcess ()))){
checkFailCounter ();}return ((0x0134+ 9544-0x267c));}main::nxclose ($SERVER_FH);
return ((0x0fe7+ 4388-0x210a));}sub removeRedisServerLockFileHandle{if ((
$lockFileHandle!=(-(0x116c+ 1092-0x15af)))){main::nxclose ($lockFileHandle);(
$lockFileHandle=(-(0x11e3+ 4216-0x225a)));}}sub setRedisServerLockFileHandle{(
$lockFileHandle=shift (@_));}sub setNxDirInNXHomeDirOwner{(my $path=
NXPaths::getUserNXHomeDir ());my ($errorMsg);if (($path eq (""))){return (
(0x0db0+ 2429-0x172d));}if ((Common::NXFile::directoryExists ($path)==
(0x098f+ 5379-0x1e92))){if ((not (Common::NXPaths::makePath ((\$errorMsg),$path)
))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$path)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMsg)."\x2e"));
return ((0x14fc+   6-0x1502));}}Common::NXFile::setOwnershipForUserNX ($path,(
\$errorMsg));Common::NXFile::setPermissionsFullForNXDirectory ($path,(\$errorMsg
));libnxh::NXTransSetEnvironment ("\x48\x4f\x4d\x45",$path);($path.=(
$GLOBAL::DIRECTORY_SLASH."\x2e\x6e\x78"));if ((Common::NXFile::directoryExists (
$path)==(0x11da+ 2736-0x1c8a))){Common::NXPaths::createAccessibleForNXDirectory 
((\$errorMsg),$path);}else{Common::NXFile::setOwnershipForUserNX ($path,(
\$errorMsg));Common::NXFile::setPermissionsFullForNXDirectory ($path,(\$errorMsg
));}}sub getMessageStartAcquire{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x73\x74\x61\x72\x74\x65\x64\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x2e"
);return ($msg);}sub getMessageAcquireDone{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x64\x64\x65\x64\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x2e"
);return ($msg);}sub getMessageAcquireFail{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x63\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x61\x64\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x2e"
);return ($msg);}sub __killOtherRedisServer{(my $serverPid=shift (@_));if (
NXTerminate::checkProcessBeforeKill ($serverPid,
"\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 if (Common::NXProcess::sigterm (
$serverPid)){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x64\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}(my $result=Common::NXProcess::waitProcess ($serverPid,
(0x0c27+ 3518-0x19d6)));if (NXTerminate::checkProcessBeforeKill ($serverPid,
"\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 if (Common::NXProcess::sigkill (
$serverPid)){if ((not (unlink ($redisLock)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4b\x69\x6c\x6c\x65\x64\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}}}}sub __getRedisServerPid{(my $redisLockFile=
getRedisPidFile ());(my $pid=(-(0x119a+ 2075-0x19b4)));my ($FH);($FH=
main::nxopen ($redisLockFile,$NXBits::O_RDONLY,(0x0d93+ 4331-0x1e7e)));if ((not 
(defined ($FH)))){(my $errorstring=libnxh::NXGetErrorString ());Logger::error ((
(((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x3a\x20"
.$redisLockFile)."\x3a\x20").$errorstring)."\x2e"));return ((""));}else{(my $r_b
=main::nxread ($FH,(\$pid),(0x2245+ 545-0x2266)));main::nxclose ($FH);if (($r_b
==(0x107b+ 4987-0x23f6))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x70\x69\x64\x20\x69\x6e\x3a\x20"
.$redisLockFile)."\x2e"));}}return ($pid);}sub __getCommandNameFromLine{(my $cmdLine
=shift (@_));(my $commandName=(""));(($commandName)=($cmdLine=~ /command=(.*),service/ )
);if (($commandName eq (""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6e\x61\x6d\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$cmdLine)."\x27\x2e"));}return ($commandName);}sub __checkCommandLine{(my $ref_msg
=shift (@_));(my $msg=$$ref_msg);if ((($msg=~ /key=\n/ )or ($msg=~ /key=,/ ))){
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6b\x65\x79\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));
return ((0x0854+ 3507-0x1606));}if ((($msg=~ / / )and (not (($msg=~ /command=script,service=db,/ )
)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x61\x69\x6e\x20\x73\x70\x61\x63\x65\x73\x2e"
));return ((0x0a4c+ 3110-0x1671));}if (($msg=~ /^(.*),field=(.*),value=,/ )){
Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x69\x65\x6c\x64\x20".$2).
"\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27").$msg
)."\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));(
$$ref_msg=~ s/,field=$2,value=,/,/ );return (__checkCommandLine ($ref_msg));}if 
(($msg=~ /^(.*),field=(.*),value=\n/ )){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x69\x65\x6c\x64\x20".$2).
"\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27").$msg
)."\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));(
$$ref_msg=~ s/,field=$2,value=\n/\n/ );return (__checkCommandLine ($ref_msg));}
if ((($msg=~ /=,/ )or ($msg=~ /=\n/ ))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x65\x6d\x70\x74\x79\x20\x66\x69\x65\x6c\x64\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg)."\x27\x2e"));return ((0x1910+ 3484-0x26ab));}if ((not (($msg=~ /\n$/ ))))
{Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6d\x69\x73\x73\x69\x6e\x67\x20\x6e\x65\x77\x20\x6c\x69\x6e\x65\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x20\x61\x74\x20\x74\x68\x65\x20\x65\x6e\x64\x20\x6f\x66\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$msg)."\x27\x2e"));($$ref_msg.="\x0a");return (__checkCommandLine ($ref_msg));}
if ((($msg=~ /command=(hmset|hset|set),service=db/ )and ((not (($msg=~ /field=(.*)/ )
))and (not (($msg=~ /value=(.*)/ )))))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6e\x6f\x74\x68\x69\x6e\x67\x2e"
));return ((0x222a+ 763-0x2524));}if (((length ($msg)>16383)and (not (($msg=~ /command=evalsha,service=db,/ )
)))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x69\x73\x20\x6c\x6f\x6e\x67\x65\x72\x20\x74\x68\x61\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x6d\x61\x78\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x73\x20\x73\x65\x74\x74\x69\x6e\x67\x73\x3a\x20\x31\x36\x33\x38\x33\x2e"
);return ((0x1d92+ 824-0x20c9));}return ((0x0dd8+ 1168-0x1268));}sub 
resendWaitingCommands{(my $resend=(0x12ed+ 4018-0x229f));(my (@newCommandList)=
());unless (@sendCommandList){return ((0x0ef7+ 5901-0x2604));}(my (
@tmpCommandList)=@sendCommandList);(@waitingCommandList=());(@sendCommandList=()
);foreach my $command (@tmpCommandList){if (($command=~ /command=connect/ )){
next;}if (($command=~ /command=auth/ )){next;}if ((sendToDb ($command)==
(0x0444+ 5879-0x1b3b))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x72\x65\x73\x65\x6e\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$command)."\x2e"));last;}else{push (@newCommandList,$command);}}if (
@newCommandList){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x72\x65\x73\x65\x6e\x64\x20"
.join ($",@newCommandList))."\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x73\x2e"));(
$resendSuccess=(0x15ca+ 4417-0x270a));(@waitingCommandList=@newCommandList);(
@sendCommandList=@newCommandList);return ((0x04ef+ 2753-0x0faf));}return (
(0x0a15+ 7298-0x2697));}sub checkFailure{if (checkRedisFlock ()){($connected=
(0x0598+ 492-0x0784));(my $redisLockFile=getRedisLockFile ());if ((
Common::NXFile::fileExists ($redisLockFile)==(0x052b+ 8411-0x2605))){unlink (
$redisLockFile);}}if ((($connected==(0x0a90+ 7098-0x264a))or (
__checkIfActualRedisServerPid ()==(0x0467+ 1696-0x0b07)))){($connected=
(0x1db6+ 116-0x1e2a));$selector->remove ($readRedis);$selector->remove (
$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});if ((resendWaitingCommands ()==
(0x0cbd+ 4065-0x1c9d))){return ((0x0959+ 3570-0x174b));}return (
(0x0055+ 7751-0x1e9b));}return ((0x1073+ 3125-0x1ca8));}sub 
__checkIfActualRedisServerPid{my ($actualRedisServerPid);if (($redisServerPid==(
-(0x07b2+ 6824-0x2259)))){return ((0x05bd+ 6846-0x207b));}if ((
Common::NXFile::fileExists (getRedisLockFile ())==(0x064f+ 7293-0x22cb))){(
$actualRedisServerPid=__getRedisServerPid ());}else{return (
(0x1e05+ 1168-0x2295));}if (($actualRedisServerPid==$redisServerPid)){return (
(0x0d1f+ 3209-0x19a7));}return ((0x18b3+ 1533-0x1eb0));}sub 
prepareMultipleCommands{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x6d\x75\x6c\x74\x69\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub executeCommands{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x65\x63\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub executeCommandsAndSave{sendToDbAndSave (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x65\x63\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub isConnected{return ($connected);}sub setDisconnected{($connected=
(0x0804+ 1817-0x0f1d));}sub __handleRedisErrorIfPossible{(my $response=shift (@_
));if (($response=~ /LOADING Redis is loading the dataset in memory/ )){
resendWaitingCommands ();return ((0x248a+ 477-0x2666));}elsif (($response=~ /ERR unknown command/ )
){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x75\x6e\x6b\x6e\x6f\x77\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x0e97+ 5241-0x2310)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67"));shift (@waitingCommandList);shift (
@sendCommandList);resendWaitingCommands ();return ((0x13ac+ 2351-0x1cda));}elsif
 (($response=~ /Error compiling script/ )){main::nxexit ((0x178f+ 2169-0x2008));
}elsif (($response=~ /Error running script/ )){main::nxexit (
(0x0466+ 7690-0x2270));}elsif (($response=~ /WRONGTYPE/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x72\x6f\x6e\x67\x20\x74\x79\x70\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x0691+ 3979-0x161c)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x2e"));shift (@waitingCommandList);
shift (@sendCommandList);resendWaitingCommands ();return ((0x04a1+ 2440-0x0e28))
;}elsif (($response=~ /ERR wrong number of arguments/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x72\x6f\x6e\x67\x20\x6e\x75\x6d\x62\x65\x72\x20\x6f\x66\x20\x61\x72\x67\x75\x65\x6d\x6e\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x04e2+ 6882-0x1fc4)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x2e"));shift (@waitingCommandList);
shift (@sendCommandList);resendWaitingCommands ();return ((0x102b+ 1121-0x148b))
;}elsif (($response=~ /NOSCRIPT No matching script/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x73\x63\x72\x69\x70\x74\x20\x27"
.$waitingCommandList[(0x19fa+ 3007-0x25b9)]).
"\x27\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
));shift (@waitingCommandList);shift (@sendCommandList);
NXRedisScript::loadAllScriptsToDb ();return ((0x01c0+ 801-0x04e0));}return (
(0x0537+ 3950-0x14a5));}sub saveRedisPid{(my $pidFile=getRedisPidFile ());(my $PID_FH
=main::nxopen ($pidFile,(($NXBits::O_WRONLY+$NXBits::O_CREAT)+$NXBits::O_TRUNC),
(($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)));if (defined 
($PID_FH)){main::nxwrite ($PID_FH,$ $);
 main::nxclose ($PID_FH);if (
main::effectiveUserIsAdministrator ()){my ($errorMsg);if ((
Common::NXFile::setOwnershipForUserNX ($pidFile,(\$errorMsg))==(-
(0x0620+ 3870-0x153d)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20\x27"
.$pidFile)."\x27\x20").$errorMsg)."\x2e"));}}}else{(my $error=
libnxh::NXGetErrorName ());Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x74\x6f\x20\x73\x61\x76\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x70\x69\x64\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$error)."\x2e"));}}sub checkIfLastOperationWentOk{($errorDuringLastCommand=
(0x1b3f+ 278-0x1c55));(my $result=get ());if ((($result ne (""))and (
$errorDuringLastCommand==(0x085f+ 1468-0x0e1b)))){return ((0x0867+ 4719-0x1ad5))
;}return ((0x0a99+ 6370-0x237b));}sub checkIfSubscriptionShouldBeStarted{if ((
$serverInit==(0x0616+ 7001-0x216f))){return ((0x0569+ 7818-0x23f2));}elsif (
Server::isDaemonProcess ()){return ((0x00e5+ 1305-0x05fd));}else{return (
(0x12e2+ 2155-0x1b4d));}}sub setServerType{(my $type=shift (@_));(my $name=(""))
;sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x67\x65\x74\x6e\x61\x6d\x65\x0a"
);(my $oldName=get ());($oldName=main::urldecode ($oldName));if ((($oldName eq 
(""))or ($oldName eq "\x6e\x6f\x74\x20\x73\x65\x74"))){($name=$type);}else{(
$name=(($oldName."\x20").$type));}($name=main::urlencode ($name));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x73\x65\x74\x6e\x61\x6d\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$name)."\x0a"));}sub unsetServerType{(my $type=shift (@_));(my $name=(""));
sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x67\x65\x74\x6e\x61\x6d\x65\x0a"
);(my $oldName=get ());($oldName=main::urldecode ($oldName));if (($oldName=~ /$type/ )
){($name=$oldName);($name=~ s/ \b$type\b// );($name=~ s/\b$type\b *// );if ((
$name eq (""))){($name="\x6e\x6f\x74\x20\x73\x65\x74");}($name=main::urlencode (
$name));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x73\x65\x74\x6e\x61\x6d\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$name)."\x0a"));}}sub handleCommandSuccesful{(my $command=shift (@_));if ((
$command eq (""))){return ((0x0660+ 8169-0x2649));}if (($command=~ /command=(.*),error=0/ )
){if (($command=~ /command=multi/ )){($multiCommand=(0x0dd6+ 2741-0x188a));
return ((0x0510+ 3826-0x1402));}if ((($command=~ /command=exec/ )and (
$multiCommand>(0x0834+ 6728-0x227c)))){splice (@sendCommandList,
(0x1f1a+ 1031-0x2321),($multiCommand+(0x16bd+ 3443-0x242f)));($multiCommand=
(0x0154+ 5964-0x18a0));return ((0x0b92+ 2819-0x1695));}if (($multiCommand>
(0x03d1+ 6720-0x1e11))){(++$multiCommand);return ((0x0d20+ 5275-0x21bb));}(my $firstSendCommand
=__getCommandNameFromLine ($sendCommandList[(0x0298+ 8585-0x2421)]));if ((
$command=~ /command=(.*),error/ )){(my $receivedCommand=$1);if ((
$receivedCommand eq $firstSendCommand)){shift (@sendCommandList);return (
(0x0f21+ 4499-0x20b4));}else{Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x55\x6e\x65\x78\x70\x65\x63\x74\x65\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x27"
.$command)."\x27\x2e\x20\x57\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x27").
$firstSendCommand)."\x27\x2e"));(my $secondSendCommand=__getCommandNameFromLine 
($sendCommandList[(0x1868+ 2668-0x22d3)]));if (($receivedCommand eq 
$secondSendCommand)){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$firstSendCommand).
"\x27\x20\x69\x73\x20\x6d\x69\x73\x73\x69\x6e\x67\x2e\x20\x50\x72\x6f\x63\x65\x65\x64\x20\x77\x69\x74\x68\x20\x73\x65\x63\x6f\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));shift (@sendCommandList);shift (@sendCommandList);return (
(0x0c42+ 647-0x0ec9));}return ((0x0519+ 3615-0x1337));}}}elsif ((($command=~ /command=(.*),error=(\d+)/ )
or ($connected==(0x19c2+ 2460-0x235e)))){if ((__handleRedisErrorIfPossible (
$response)==(0x0925+ 6196-0x2158))){return ((0x0243+ 3354-0x0f5c));}return (
(0x05b2+ 5585-0x1b83));}}sub commandMonitor{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x6d\x6f\x6e\x69\x74\x6f\x72\x20\x72\x65\x64\x69\x73\x2e"
);sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x6d\x6f\x6e\x69\x74\x6f\x72\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);(@sendCommandList=());while ((0x0678+ 4129-0x1698)){(my (@ready)=$selector->
can_read ((0x17ff+ 6617-0x2620)));foreach my $fh (@ready){if (($fh eq $readRedis
)){my ($read_buf);(my $bytes_read=main::nxread ($readRedis,(\$read_buf),32768));
if ((($bytes_read eq (0x0bf6+ 4359-0x1cfd))or ($bytes_read eq ("")))){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x53\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x09f3+ 1777-0x10e4));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x4d\x6f\x6e\x69\x74\x6f\x72\x20\x72\x65\x74\x75\x72\x6e\x3a\x20"
.$response)."\x2e"));main::nxwrite (main::nxgetSTDOUT (),$response);}}}if (
NXShell::isExitRequestReceivedSIGINT ()){$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});$selector->remove ($readRedis);main::nxclose (
$readRedis);($readRedis=(""));($connected=(0x02b7+ 8221-0x22d4));return ((""));}
}}sub commandDebug{(my $param=shift (@_));(my (@params)=split ( / / ,$param,
(0x01b0+ 786-0x04c2)));shift (@params);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.join ($",@params))."\x2e"));(my $command=shift (@params));(my $key=shift (
@params));if (($command eq (""))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x13dd+ 1053-0x17fa));}(my $redisCommand=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d".$command).
"\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62"));if (($key ne (""))){(
$redisCommand.=("\x2c\x6b\x65\x79\x3d".$key));}foreach my $field (@params){(
$redisCommand.=("\x2c\x66\x69\x65\x6c\x64\x3d".$field));}($redisCommand.="\x0a")
;sendToDb ($redisCommand);main::nxwrite (main::nxgetSTDOUT (),(get ()."\x0a"));}
sub commandInfo{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x69\x6e\x66\x6f\x20\x72\x65\x64\x69\x73\x2e"
);sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x69\x6e\x66\x6f\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);(@sendCommandList=());while ((my (@ready)=$selector->can_read (
(0x2032+ 1533-0x1a77)))){foreach my $fh (@ready){if (($fh eq $readRedis)){my (
$read_buf);(my $bytes_read=main::nxread ($readRedis,(\$read_buf),32768));if (((
$bytes_read eq (0x02aa+ 5354-0x1794))or ($bytes_read eq ("")))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x73\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x0fb7+ 1647-0x1626));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x49\x6e\x66\x6f\x20\x72\x65\x74\x75\x72\x6e\x3a\x20"
.$response)."\x2e"));main::nxwrite (main::nxgetSTDOUT (),$response);closeDb ();
return;}}}}}sub commandScript{(my $param=shift (@_));(my (@params)=split ( / / ,
$param,(0x0a93+ 2031-0x1282)));shift (@params);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x73\x63\x72\x69\x70\x74\x3a\x20"
.join ($",@params))."\x2e"));(my $scriptName=shift (@params));if (($scriptName 
eq (""))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x53\x63\x72\x69\x70\x74\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x05ff+ 1700-0x0ca3));}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x63\x72\x69\x70\x74");(my (@args)=());(my $returnValue
=NXRedisScript::executeScript ($scriptName,(\@args),(\@params)));if ((
$scriptName eq 
"\x67\x65\x74\x41\x6c\x6c\x44\x61\x74\x61\x46\x72\x6f\x6d\x53\x65\x74")){(
$returnValue=~ s/^"// );($returnValue=~ s/"$// );(my (@data)=split ( /" "/ ,
$returnValue,(0x0f84+ 1389-0x14f1)));foreach my $singleData (@data){(my (%hash)=
split ( / / ,$singleData,(0x045f+ 7185-0x2070)));foreach my $key (keys (%hash)){
main::nxwrite (main::nxgetSTDOUT (),((($key."\x3a\x20").$hash{$key})."\x0a"));}
main::nxwrite (main::nxgetSTDOUT (),"\x0a");}}else{main::nxwrite (
main::nxgetSTDOUT (),$returnValue);}}sub checkFailCounter{(++$failCounter);if ((
$failCounter==(0x0e2f+ 2706-0x18c0))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x63\x65\x20\x63\x6f\x6e\x65\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x2e"
);}elsif (($failCounter==(0x16ba+ 3233-0x2359))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x74\x77\x69\x63\x65\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x2e"
);}if (($failCounter>(0x0f00+ 5590-0x24d4))){if (($finalizeProcessStarted==
(0x1032+ 5769-0x26ba))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x20"
.$failCounter).
"\x20\x74\x69\x6d\x65\x73\x2e\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x61\x72\x74\x65\x64\x2e"
));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x20"
.$failCounter).
"\x20\x74\x69\x6d\x65\x73\x2e\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));main::nxexit ((0x16e1+ 2224-0x1f91));}}return;}sub forceCloseRedisClient{(
$connected=(0x0400+ 8598-0x2595));closeDb ();}sub 
checkFailCounterAndCloseIfNeeded{if (($serverInit==(0x0155+ 7311-0x1de3))){
return;}if (($failCounter>(0x027a+ 5953-0x19ba))){shift (@sendCommandList);
forceCloseRedisClient ();}checkFailCounter ();}sub cleanCommandList{while ((
scalar (@sendCommandList)>(0x0b13+ 4928-0x1e53))){get ();}}sub isSaveDone{(my $response
=shift (@_));if ((($response eq "\x4f\x4b")or ($response eq 
"\x42\x61\x63\x6b\x67\x72\x6f\x75\x6e\x64\x20\x73\x61\x76\x69\x6e\x67\x20\x73\x74\x61\x72\x74\x65\x64"
))){return ((0x035c+ 4772-0x15ff));}return ((0x13c5+ 1010-0x17b7));}sub 
waitForAllCommands{while ((scalar (@sendCommandList)>(0x0136+ 2353-0x0a67))){(my $command
=__getCommandNameFromLine ($sendCommandList[(0x10e5+ 5041-0x2496)]));
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$command)."\x27\x2e"));get ();}}sub doNotCloseRedisThreadsOnExit{(
$doNotCloseRedisThreadsWhenFreePerl=(0x0e63+ 885-0x11d7));}NXMsg::register_error
 ("\x4e\x58\x52\x65\x64\x69\x73",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4e\x78\x73\x65\x72\x76\x65\x72\x53\x68\x75\x74\x64\x6f\x77\x6e"
,(0x0570+ 1757-0x0a59));"\x3f\x3f\x3f";
