############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub Common::NXTime::getSecondsSinceEpoch{package Common::NXTime;no warnings;(my $seconds
=libnxh::NXGetTime ());return ($seconds);}sub 
Common::NXTime::getSecondsAndMicrosecondsSinceEpoch{package Common::NXTime;no 
warnings;(my $buffer=("\x3a" x (0x01f6+ 1015-0x05c5)));my (@arr);my (@result);(my $retval
=libnxh::NXSecondsAndMicrosecondsSinceEpoch ($buffer));if (($retval!=(-
(0x2204+ 1119-0x2662)))){(@arr=split ( /:/ ,$buffer,(0x0586+ 8051-0x24f9)));(
@result=splice (@arr,(0x0930+ 555-0x0b5b),(0x1adc+ 2401-0x243b)));return (
@result);}else{(my $errorNumber=libnxh::NXGetError ());(my $errorString=
libnxh::NXGetErrorString ());syswrite (STDERR,
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x74\x69\x6d\x65\x20\x77\x69\x74\x68\x20\x6d\x69\x63\x72\x6f\x73\x65\x63\x6f\x6e\x64\x20\x70\x72\x65\x63\x69\x73\x69\x6f\x6e\x2e\x0a"
);syswrite (STDERR,((((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errorNumber)."\x2c\x20\x27").$errorString)."\x27\x2e\x0a"));main::nxexit ();}}
sub Common::NXTime::getMillisecondsSinceEpoch{package Common::NXTime;no warnings
;(my ($seconds,$microseconds)=getSecondsAndMicrosecondsSinceEpoch ());(my $milliseconds
=int ((($seconds *(0x0504+ 6599-0x1ae3))+($microseconds/(0x1d9b+ 2495-0x2372))))
);return ($milliseconds);}sub Common::NXTime::getLocalTime{package 
Common::NXTime;no warnings;my (@arr);my (@result);(my $buffer=("\x3a" x 
(0x03b1+ 5115-0x1784)));(my $retval=libnxh::NXLocalTime ($buffer));if (($retval
!=(-(0x0b98+ 1211-0x1052)))){(@arr=split ( /:/ ,$buffer,(0x0e5f+ 458-0x1029)));(
@result=splice (@arr,(0x02c4+ 5152-0x16e4),(0x0a2a+ 3582-0x181f)));return (
@result);}else{(my $errorNumber=libnxh::NXGetError ());(my $errorString=
libnxh::NXGetErrorString ());syswrite (STDERR,
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x74\x69\x6d\x65\x2e\x0a"
);syswrite (STDERR,((((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errorNumber)."\x2c\x20\x27").$errorString)."\x27\x2e\x0a"));main::nxexit ();}}
sub Common::NXTime::getLocalTimeFromTimestamp{package Common::NXTime;no warnings
;(my $stamp=shift (@_));my (@arr);my (@result);(my $buffer=("\x3a" x 
(0x0431+ 1747-0x0adc)));(my $retval=libnxh::NXLocalTimeFromTimestamp ($stamp,
$buffer));if (($retval!=(-(0x1f53+ 1376-0x24b2)))){(@arr=split ( /:/ ,$buffer,
(0x0494+ 7653-0x2279)));(@result=splice (@arr,(0x01b4+ 4309-0x1289),
(0x18f5+ 1751-0x1fc3)));return (@result);}else{(my $errorNumber=
libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());syswrite (
STDERR,((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x74\x69\x6d\x65\x2e\x20\x41\x72\x67\x75\x6d\x65\x6e\x74\x20\x69\x73\x20"
.$stamp)."\x2e\x0a"));syswrite (STDERR,((((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errorNumber)."\x2c\x20\x27").$errorString)."\x27\x2e\x0a"));main::nxexit ();}}
sub Common::NXTime::getDateString{package Common::NXTime;no warnings;(my $string
=libnxh::NXLocalTimeAsString ());return ($string);}sub 
Common::NXTime::getTimestamp{package Common::NXTime;no warnings;(my ($sec,
$microsec)=getSecondsAndMicrosecondsSinceEpoch ());(my (@time)=
getLocalTimeFromTimestamp ($sec));(my $milisec=sprintf ("\x25\x30\x36\x64",
$microsec));($milisec=((substr ($milisec,(0x0244+ 463-0x0413),
(0x11f7+ 3804-0x20d0))."\x2e").substr ($milisec,(0x241a+ 116-0x248b))));(my $Timestamp
=((((((sprintf ("\x25\x30\x32\x64",$time[(0x0fcf+ 3521-0x1d8e)])."\x3a").sprintf
 ("\x25\x30\x32\x64",$time[(0x15f8+ 3144-0x223f)]))."\x3a").sprintf (
"\x25\x30\x32\x64",$time[(0x0366+ 6564-0x1d0a)]))."\x3a").sprintf ($milisec)));
return ($Timestamp);}sub Common::NXTime::getTimestampOnlyMicroseconds{package 
Common::NXTime;no warnings;(my ($sec,$microsec)=
getSecondsAndMicrosecondsSinceEpoch ());(my $milisec=sprintf ("\x25\x30\x36\x64"
,$microsec));($milisec=((substr ($milisec,(0x0942+ 7304-0x25ca),
(0x0064+ 3033-0x0c3a))."\x2e").substr ($milisec,(0x0b61+ 3829-0x1a53))));(my $Timestamp
=sprintf ($milisec));return ($Timestamp);}sub Common::NXTime::__getTimeMs{
package Common::NXTime;no warnings;(my ($sec,$microsec)=
getSecondsAndMicrosecondsSinceEpoch ());(my (@time)=getLocalTimeFromTimestamp (
$sec));(my $milisec=sprintf ("\x25\x30\x36\x64",$microsec));($milisec=(substr (
$milisec,(0x00c7+ 5779-0x175a),(0x1a4b+ 2491-0x2403)).substr ($milisec,
(0x0d39+ 440-0x0eee))));return ($milisec,@time);}sub Common::NXTime::getTimeMs{
package Common::NXTime;no warnings;(my ($milisec,@time)=__getTimeMs ());(my $TimeMs
=((((sprintf ("\x25\x30\x32\x64",$time[(0x1b6a+ 748-0x1e54)]).sprintf (
"\x25\x30\x32\x64",$time[(0x11c4+ 389-0x1348)])).sprintf ("\x25\x30\x32\x64",
$time[(0x0192+ 5188-0x15d6)]))."\x2e").sprintf ($milisec)));return ($TimeMs);}
sub Common::NXTime::getLoggerTimeline{package Common::NXTime;no warnings;(my (
$milisec,@time)=__getTimeMs ());($milisec=((substr ($milisec,
(0x0cbc+ 4764-0x1f58),(0x05d0+ 5269-0x1a62))."\x2e").substr ($milisec,
(0x092c+ 4927-0x1c68))));(my $Timeline=(sprintf (
"\x25\x30\x34\x64\x2d\x25\x30\x32\x64\x2d\x25\x30\x32\x64\x20\x25\x30\x32\x64\x3a\x25\x30\x32\x64\x3a\x25\x30\x32\x64\x20"
,((0x16f2+ 347-0x10e1)+$time[(0x024b+ 3630-0x1074)]),((0x0e76+ 1778-0x1567)+
$time[(0x1617+ 2003-0x1de6)]),$time[(0x00bb+ 5312-0x1578)],$time[
(0x149d+ 2555-0x1e96)],$time[(0x087f+ 4660-0x1ab2)],$time[(0x0442+ 6831-0x1ef1)]
).$milisec));return ($Timeline);}sub 
Common::NXTime::getLoggerTimelineOnlyMicroseconds{package Common::NXTime;no 
warnings;(my ($milisec,@time)=__getTimeMs ());($milisec=((substr ($milisec,
(0x07c8+ 7646-0x25a6),(0x06c9+ 4500-0x185a))."\x2e").substr ($milisec,
(0x06f8+ 7691-0x2500))));(my $Timeline=sprintf ($milisec));return ($Timeline);}
sub Common::NXTime::convertLocalTimeFromTimestampToHumanReadableString{package 
Common::NXTime;no warnings;(my $timestamp=shift (@_));(my (@time)=
getLocalTimeFromTimestamp ($timestamp));(my $timeString=sprintf (
"\x25\x30\x34\x64\x2d\x25\x30\x32\x64\x2d\x25\x30\x32\x64\x20\x25\x30\x32\x64\x3a\x25\x30\x32\x64\x3a\x25\x30\x32\x64"
,((0x0abc+ 4831-0x162f)+$time[(0x1fd5+ 476-0x21ac)]),($time[(0x1077+ 780-0x137f)
]+(0x1a27+ 169-0x1acf)),$time[(0x1383+ 475-0x155b)],$time[(0x06d2+ 2423-0x1047)]
,$time[(0x015c+ 4531-0x130e)],$time[(0x0a8d+ 5850-0x2167)]));return ($timeString
);}sub Common::NXTime::getDateTimeForFileName{package Common::NXTime;no warnings
;(my $dateTime=getLoggerTimeline ());($dateTime=~ s/ [^ ]*$// );($dateTime=~ s/-/./gm )
;($dateTime=~ s/:/./gm );($dateTime=~ s/ /-/gm );return ($dateTime);}sub 
Common::NXTime::getSecondsInWeek{package Common::NXTime;no warnings;return (
604800);}sub Common::NXTime::convertSecondsToDaysRounded{package Common::NXTime;
no warnings;(my $seconds=shift (@_));(my $days=($seconds/86400));($days=(int (
$days)+(0x0b9a+ 5584-0x2169)));return ($days);}package Common::NXTime;no 
warnings;"\x3f\x3f\x3f";
